{* this is a simple program for mpcalc.pas which tests all the operators
   and functions by using some expressions.

   Copyright (C) 1999 Franco Milani (franco@intercity.it)

   You can use or modify this program for personal purposes. You can also
   redistribute it, but only in the original unmodified form. The possible
   changes in the distributed versions will be made by the author, also
   according to hints, requests or bug reports. 

   This program is released in the hope that it will be useful, but on an
   as-is basis. No warranty of any kind is offered, either expressed or
   implied, including, without limitation, the implied warranties of
   merchantability and fitness for a particular purpose.                  *}

{$H+}
program mptest;

uses crt,mpcalc;

const
sa : array[1..7] of string[79] =
('7.0882551839551678581635440360684614471605536424863059427704205025718325586539',
'-3.35082266355',
'-2.4399858642286990290602877601345981503497894382490203681806148957373810062259',
'0.0702567339893539719272986283038650030152835106217429473763844491537664916286',
'0.7784738367354722102845578954168967867243541966790809662525308301743617385784',
'11931.445820040816605789601026358593814673541151412656144711873403383069938958',
'0.459330498979963691322358200598345974956295542933966677690625151300729733468');

var
prec,myprec : word;
a,b,r : mp;
s : string;
c : char;

procedure endtest(b: byte);
begin
xapp(r,r,myprec);
xdis(r);
xtostr(r,s);
writeln('must be');
if sa[b][1]<>'-' then write('+');
writeln(sa[b]);
if sa[b]=s then writeln('exact value, ok')
else writeln(#7#7#7#7#7,'different values, something is wrong!');
writeln;
if b<7 then begin
write('press a key, <space> to exit... ');
c:=readkey;
writeln;
if c=#32 then halt;
writeln;
end
else writeln('end of test, bye.');
end;

begin
prec:=82;
myprec:=77;
xprecision(prec);
a:=0.9876543212;
b:=-1.2983546729;
writeln;
writeln('test 1/7: operations');
r:=a+b+a*(-b)-a/2-b/a*(a**b)+mpi/a-meu/b;
endtest(1);
writeln('test 2/7: functions mabs(), mint(), mfrac(), msign(), mceil(), mfloor(), msqr()');
r:=mabs(b/2)+mint(a/b)*mfrac(b/a)*msign(b-a)-mceil(msqr(b/a))+mfloor(b/(msqr(a)));
endtest(2);
writeln('test 3/7: functions msqrt(), mfact(), mexp(), mln(), mlog()');
r:=msqrt(a/3)/mfact(mint(mabs(b*10)))-mexp(a)*mln(a*2.5)/mlog(a*10);
endtest(3);
writeln('test 4/7: functions msin(), mcos(), mtan(), mcot(), msec(), mcsc()');
r:=msin(b-a)*(1/mcos(b+a))/mtan(a-0.233)*mcot(b+9.002)/msec(1/a)*mcsc(b);
endtest(4);
writeln('test 5/7: functions masin(), macos(), matan(), macot(), masec(0, macsc()');
r:=masin(a/2)*macos(a/3)/matan(b/2)*macot(b/3)/masec(b/a)*macsc(b/a);
endtest(5);
writeln('test 6/7: functions msinh(), mcosh(), mtanh(), mcoth(), msech(), mcsch()');
r:=msinh(a+b)*mcosh(a-b)/mtanh(a/b)+mcoth(b/a)*msech(2.3009)/mcsch(15/b);
endtest(6);
writeln('test 7/7: functions masinh(), macosh(), matanh(), macoth(), masech(), macsch()');
r:=masinh(macosh(1+matanh(macoth(a-b))))*masech(macsch(1/a));
endtest(7);
end.
